Option Strict Off
Option Explicit On
Friend Class frm_Principal
	Inherits System.Windows.Forms.Form

    ' Compatibilidade com Visual Studio 2008
    Private IsInitializing As Boolean

    ' Porta de comunicacao (USB000  a deteco automatica default)
    Dim PortaComunicacao As String = "USB000"
	Dim boPortaAberta As Boolean
	
    Dim Velocidade As Integer
	Dim Paridade As Integer
	Dim BitsDeDados As Integer
	Dim BitsDeParada As Integer
	Dim ControleDeFluxo As Integer

	'Atributos
	Dim cmdAtivaNegrito As String
	Dim cmdDesativaNegrito As String
	Dim cmdAtivaExpandido As String
	Dim cmdDesativaExpandido As String
	Dim cmdAtivaCondensado As String
	Dim cmdDesativaCondensado As String
	Dim cmdAtivaSublinhado As String
	Dim cmdDesativaSublinhado As String
	Dim cmdAtivaItalico As String
	Dim cmdDesativaItalico As String
	Dim cmdDesativaTodosAtributos As String
	
	Const Tam_cmdAtivaNegrito As Short = 2
	Const Tam_cmdDesativaNegrito As Short = 2
	Const Tam_cmdAtivaExpandido As Short = 3
	Const Tam_cmdDesativaExpandido As Short = 3
	Const Tam_cmdAtivaCondensado As Short = 1
	Const Tam_cmdDesativaCondensado As Short = 1
	Const Tam_cmdAtivaSublinhado As Short = 3
	Const Tam_cmdDesativaSublinhado As Short = 3
	Const Tam_cmdAtivaItalico As Short = 2
	Const Tam_cmdDesativaItalico As Short = 2
	Const Tam_cmdDesativaTodosAtributos As Short = 2
	
	'Codigos de barras
	Dim cmdIntercalados2e5 As String
	Dim cmdCODE39 As String
	Dim cmdEAN8 As String
	Dim cmdEAN13 As String
	Dim cmdCode128 As String
	Dim PosicaoCodNumerico As Short
	Const TamCmdCodBarras As Short = 5
	Dim cmdQRCode As String
    Dim StrQRCode_Dados As String = "www.diebold.com.br"
    Dim StrQRCode_Tam As Short = Len(StrQRCode_Dados)
    Dim TamCmdQRCode As Short
	
	
	' Abrir Gaveta
	Dim cmdPulsoGaveta As String
	Const Tam_cmdPulsoGaveta As Short = 5
	
	' Corte (acionar guilhotina)
	Dim cmdCortePapel As String
	Const Tam_cmdCortePapel As Short = 2
	
	' Solicitacao de Status
	Dim CmdStatusTipoPapel As String
	Dim CmdStatusTipoGenerico As String
	Const TamCmdStatus As Short = 3
	Const MiliSegPrepararStatus As Short = 500 ' tempo em milisegundos para impressora preparar resposta de status
	
	Const StatusTipoPapel As Short = 1
	Const StatusTipoGenerico As Short = 2
	
	Const MASK_BIT0 As Short = 1 ' Mascara p/ Verificar Bit 0
	Const MASK_BIT1 As Short = 2 ' Mascara p/ Verificar Bit 1
	Const MASK_BIT2 As Short = 4 ' Mascara p/ Verificar Bit 2
	Const MASK_BIT3 As Short = 8 ' Mascara p/ Verificar Bit 3
	Const MASK_BIT4 As Short = 16 ' Mascara p/ Verificar Bit 4
	Const MASK_BIT5 As Short = 32 ' Mascara p/ Verificar Bit 5
	Const MASK_BIT6 As Short = 64 ' Mascara p/ Verificar Bit 6
	Const MASK_BIT7 As Short = 128 ' Mascara p/ Verificar Bit 7
	
	
	'Valores padrao para Timeout de RX e TX
	Const ValorTimeOutRX As Short = 2000
	Const ValorTimeOutTX As Short = 5000
	
    Const TamBlocosLeituraArq As Short = 1024 * 3
    Const TamBlocosLeituraPorta As Short = 10

	' Define o tempo (em milisegundos) para aguardar a execuo das funes
	Const AguardarQtosMs As Short = 20
	
	' Define o numero de tentativas de escrita em caso de erro
	Const NumTentativasEscrita As Short = 5
	
	' Numero de bytes enviados: preenchido na funcao [EscreverNaPorta()] e usado na funcao [AguardaImpressao()]
	Dim NumBytesEnviados As Integer

    Dim tempDrive As String

	Private Sub InitVariavelCmd()
		'Solicitao de status
		CmdStatusTipoPapel = Chr(&H10) & Chr(&H2) & Chr(&H1)
		CmdStatusTipoGenerico = Chr(&H10) & Chr(&H2) & Chr(&H2)
		
		'Abrir Gaveta
		cmdPulsoGaveta = Chr(27) & Chr(&H26) & Chr(&H30) & Chr(12) & Chr(48)
		
		'Corte de Papel
		cmdCortePapel = Chr(&H1B) & "w"
		
		'Codigo de Barras
		cmdIntercalados2e5 = Chr(&H1B) & Chr(&H7C) & "1" & Chr(120) & Chr(2)
		cmdCODE39 = Chr(&H1B) & Chr(&H7C) & "2" & Chr(120) & Chr(2)
		cmdEAN8 = Chr(&H1B) & Chr(&H7C) & "4" & Chr(120) & Chr(2)
		cmdEAN13 = Chr(&H1B) & Chr(&H7C) & "0" & Chr(120) & Chr(2)
		cmdCode128 = Chr(&H1B) & Chr(&H7C) & "3" & Chr(120) & Chr(2)
		
		
		'Atributos
		cmdAtivaNegrito = Chr(27) & "E"
		cmdDesativaNegrito = Chr(27) & "F"
		cmdAtivaExpandido = Chr(27) & Chr(87) & Chr(49)
		cmdDesativaExpandido = Chr(27) & Chr(87) & Chr(48)
		cmdAtivaCondensado = Chr(15)
		cmdDesativaCondensado = Chr(18)
		cmdAtivaSublinhado = Chr(27) & "-" & "1"
		cmdDesativaSublinhado = Chr(27) & "-" & "0"
		cmdAtivaItalico = Chr(27) & "4"
		cmdDesativaItalico = Chr(27) & "5"
		cmdDesativaTodosAtributos = Chr(27) & "H"
	End Sub
	
    Private Function AbrirPorta() As Boolean
        Dim lret As Integer

        AbrirPorta = False

        Velocidade = 0
        Paridade = 0
        BitsDeDados = 0
        BitsDeParada = 0
        ControleDeFluxo = 0

        'Porta = Serial
        If Opt_PortaSerial.Checked = True Then
            'Serial = COM1 a COM10
            PortaComunicacao = "COM" & (cmb_PortaSerial.SelectedIndex + 1)

            'Velocidade(bps) = 9600, 19200, 38400, 57600 ou 115200
            If cmb_Velocidade.SelectedIndex = 0 Then
                Velocidade = 9600
            ElseIf cmb_Velocidade.SelectedIndex = 1 Then
                Velocidade = 19200
            ElseIf cmb_Velocidade.SelectedIndex = 2 Then
                Velocidade = 38400
            ElseIf cmb_Velocidade.SelectedIndex = 3 Then
                Velocidade = 57600
            ElseIf cmb_Velocidade.SelectedIndex = 4 Then
                Velocidade = 115200
            Else
                Velocidade = 57600
            End If

            'Paridade = Par, mpar ou Nenhum
            If cmb_Paridade.SelectedIndex = 0 Then
                Paridade = Asc("P") 'Par
            ElseIf cmb_Paridade.SelectedIndex = 1 Then
                Paridade = Asc("I") 'mpar
            ElseIf cmb_Paridade.SelectedIndex = 2 Then
                Paridade = Asc("N") 'Nenhum
            Else
                Paridade = Asc("N") 'Nenhum
            End If

            'Bits de Dados = 8 ou 7
            If cmb_BitDados.SelectedIndex = 0 Then
                BitsDeDados = 8
            ElseIf cmb_BitDados.SelectedIndex = 1 Then
                BitsDeDados = 7
            Else
                BitsDeDados = 8
            End If

            'Bits de Parada = 1 ou 2
            If cmb_BitParada.SelectedIndex = 0 Then
                BitsDeParada = 1
            ElseIf cmb_BitParada.SelectedIndex = 1 Then
                BitsDeParada = 2
            Else
                BitsDeParada = 1
            End If

            'Controle de Fluxo (Protocolo) = Nenhum, Hardware (CTS/RTS) ou Software (XOn/XOff)
            If cmb_ControlFluxo.SelectedIndex = 0 Then
                ControleDeFluxo = 0 'Nenhum
            ElseIf cmb_ControlFluxo.SelectedIndex = 1 Then
                ControleDeFluxo = 1 'Hardware (CTS/RTS)
            ElseIf cmb_ControlFluxo.SelectedIndex = 2 Then
                ControleDeFluxo = 2 'Software (XOn/XOff)
            Else
                ControleDeFluxo = 1 'Hardware (CTS/RTS)
            End If

            ' Porta = Paralela
        ElseIf Opt_PortaParalela.Checked = True Then
            'Paralela = LPT1 ou LPT2
            If cmb_PortaParalela.SelectedIndex = 0 Then
                PortaComunicacao = "LPT1"
            ElseIf cmb_PortaParalela.SelectedIndex = 1 Then
                PortaComunicacao = "LPT2"
            Else
                PortaComunicacao = "LPT1"
            End If

            ' Porta = USB
        ElseIf Opt_PortaUSB.Checked = True Then
            'USB = USB000 ("Deteco Automtica")
            PortaComunicacao = "USB000"
        Else
            MsgBox("FALHA: Escolha a interface de comunicao.")
            Exit Function
        End If

        lret = MEGENCOM32_AbrirDispositivo(PortaComunicacao, Velocidade, Paridade, BitsDeDados, BitsDeParada, ControleDeFluxo)
        If (lret <> 0) Then
            MsgBox("FALHA: Funo: [AbrirPorta()] - Porta: [" & PortaComunicacao & "] - Retorno: [" & Str(lret) & "]")
            lret = MEGENCOM32_FecharDispositivo(PortaComunicacao)
            Exit Function
        End If

        boPortaAberta = True

        AbrirPorta = True
    End Function
	
    Private Function FecharPorta() As Boolean
        Dim lret As Integer

        FecharPorta = False

        If boPortaAberta = False Then
            Exit Function
        End If

        lret = MEGENCOM32_FecharDispositivo(PortaComunicacao)
        If (lret <> 0) Then
            MsgBox("FALHA: Funo: [FecharPorta()] - Porta: [" & PortaComunicacao & "] - Retorno: [" & Str(lret) & "]")
            Exit Function
        End If

        'Seta variavel que controla se a porta est aberta (true) ou fechada (false)
        boPortaAberta = False

        FecharPorta = True
    End Function
	
    Private Function LeraPorta(ByRef bBuffer As String, ByVal NumBytesLer As Integer, ByRef TamLido As Integer) As Boolean
        Dim lret As Integer
        Dim bBufLido As String
        Dim LerBytes As Integer
        Dim nBytesRecebidos As Integer

        ' Inicializa variaveis
        LeraPorta = True
        bBuffer = ""
        TamLido = 0

        LeraPorta = False

        Do
            ' Calcula o nmero de bytes a serem lidos
            LerBytes = NumBytesLer - TamLido

            ' Valida o nmero de bytes a serem lidos com o tamanho do bloco de cada leitura
            If LerBytes > TamBlocosLeituraPorta Then
                LerBytes = TamBlocosLeituraPorta
            End If

            ' Inicializando a rea de memria
            bBufLido = New String(Chr(&H0), LerBytes)

            ' Executa a leitura da porta e trata o retorno
            lret = MEGENCOM32_LeroDispositivo(PortaComunicacao, bBufLido, LerBytes, nBytesRecebidos)
            If lret <> 0 Then
                MsgBox("[LeraPorta()] - TamLido: [" & Str(TamLido) & "] - nBytesRecebidos: [" & Str(nBytesRecebidos) & "] - Retorno: [" & Str(lret) & "]")
                Exit Function
            ElseIf nBytesRecebidos = 0 Then
                Exit Do
            End If

            ' Armazena os bytes lidos
            bBuffer = bBuffer & bBufLido

            ' Calcula o tamanho total de bytes lidos (recebidos)
            TamLido = nBytesRecebidos + TamLido

            ' Intervalo entre leituras
            Call AguardarMilisegundos(AguardarQtosMs)
        Loop Until TamLido = NumBytesLer

        LeraPorta = True
    End Function
	
    Private Function EscreverNaPorta(ByVal bBuffer As String, ByVal TamBuffer As Integer, ByVal AguardarQtosMs As Integer) As Boolean
        Dim lret As Integer
        Dim TamEscrito As Integer
        Dim TamTotalEscrito As Integer
        Dim x As Short
        Dim iCont As Short

        EscreverNaPorta = True

        ' Se tem 0 (zero) bytes a serem escritos, retorna sucesso
        If TamBuffer = 0 Then
            Exit Function
        End If

        ' Inicializa variaveis
        TamTotalEscrito = 0
        TamEscrito = 0
        x = 1
        iCont = 0

        ' Executa enquanto houver byte a ser escrito
        Do While (((TamBuffer - TamTotalEscrito) > 0) And iCont < NumTentativasEscrita)
            x = x + TamEscrito
            lret = MEGENCOM32_EscrevernoDispositivo(PortaComunicacao, Mid(bBuffer, x, TamBuffer), TamBuffer - TamTotalEscrito, TamEscrito)
            If lret <> 0 Then
                Exit Do
            Else
                iCont = 0
            End If

            ' Calcula o tamanho total de bytes escritos (enviados)
            TamTotalEscrito = TamTotalEscrito + TamEscrito

            ' Intervalo entre escritas
            AguardarMilisegundos((AguardarQtosMs))
        Loop

        If lret <> 0 Then
            MsgBox("EscreverNaPorta() - Enviados: [" & Str(TamBuffer - TamTotalEscrito) & "] - TamEscrito: [" & Str(TamEscrito) & "] - Retorno: [" & Str(lret) & "]")
            EscreverNaPorta = False
            Exit Function
        End If

        NumBytesEnviados = TamTotalEscrito
    End Function
	Private Sub AguardarMilisegundos(ByRef QuantoTempo As Integer)
		Dim inicio As Integer
		
		' Inicializa contator
		inicio = GetTickCount()
		
		While GetTickCount() < inicio + QuantoTempo
			System.Windows.Forms.Application.DoEvents()
		End While
	End Sub
	
    Private Function LimparLeituraPorta() As Boolean
        Dim TamLido As Integer
        Dim bBuffer As String

        LimparLeituraPorta = False

        'L todos os bytes pendentes
        TamLido = 0
        Do
            bBuffer = ""
            If LeraPorta(bBuffer, 1, TamLido) = False Then
                Exit Function
            End If
        Loop Until TamLido = 0

        LimparLeituraPorta = True
    End Function
	
    Private Function AtivarLOG(ByVal CamadaLOG As Short, ByVal NivelDepuracaoLOG As Short) As Boolean
        Dim lret As Integer

        AtivarLOG = True

        ' Enviando comando para ativar a gravao de LOG
        lret = MEGENCOM32_AtivarLOG(CamadaLOG, NivelDepuracaoLOG)
        If (lret <> 0) Then
            MsgBox("FALHA: Funo: [AtivarLOG()] - Camada: [" & Str(CamadaLOG) & "] - Nvel: [" & Str(NivelDepuracaoLOG) & "] - Retorno: [" & Str(lret) & "]")
            AtivarLOG = False
            Exit Function
        End If
    End Function
	
    Private Function DesativarLOG(ByVal CamadaLOG As Short) As Boolean
        Dim lret As Integer

        DesativarLOG = True

        ' Enviando comando para desativar a gravao de LOG
        lret = MEGENCOM32_DesativarLOG(CamadaLOG)
        If (lret <> 0) Then
            MsgBox("FALHA: Funo: [DesativarLOG()] - Camada: [" & Str(CamadaLOG) & "] - Retorno: [" & Str(lret) & "]")
            DesativarLOG = False
            Exit Function
        End If
    End Function
	
    Private Function ConfigurarTimeoutRXTX(ByVal TimeoutRX As Object, ByRef TimeoutTX As Short) As Boolean
        Dim lret As Integer

        ConfigurarTimeoutRXTX = True

        ' Enviando comando para configurar o timeout de RX/TX
        lret = MEGENCOM32_ConfigurarTimeoutsRXTX(PortaComunicacao, TimeoutRX, TimeoutTX)
        If (lret <> 0) Then
            MsgBox("FALHA: [ConfigurarTimeoutRXTX)] - Funo: [MEGENCOM32_ConfigurarTimeoutsRXTX()] - Retorno: [" & Str(lret) & "]")
            ConfigurarTimeoutRXTX = False
            Exit Function
        End If
    End Function
	
    Private Function PreparaImpressao() As Boolean
        Dim lret As Integer

        PreparaImpressao = True

        lret = MEGENCOM32_PreparaImpressao(PortaComunicacao)
        If (lret <> 0) Then
            MsgBox("FALHA: Funo: [PreparaImpressao()] - Retorno: [" & Str(lret) & "]")
            PreparaImpressao = False
        End If
    End Function
	
    Private Function AguardaImpressao() As Boolean
        Dim lret As Integer
        Dim QuantosMilisegundos As Integer
        Dim addTempo As Integer

        AguardaImpressao = True

        ' No calculo do timeout QuantosMilisegundos deve-se considerar:
        '  1. Timeout minimo p/ impresso: 5000ms (5 segundos);
        '  2. Tempo para a comunicao: 1000ms (1 segundo);
        '  3. Linha preenchida com o total de caracteres disponiveis em 18,5 cpp (52 caracteres);
        '  4. Tempo para impresso de cada linha: 300ms
        '  Obs.: Se for usado o modo grfico da impressora,
        '        haver necessidade de revisar o mtodo para calcular o timeout
        QuantosMilisegundos = (5000)
        addTempo = (1000 + ((NumBytesEnviados / 52) * 300))
        If addTempo > QuantosMilisegundos Then
            QuantosMilisegundos = addTempo
        End If

        ExibeMsgAguarde(("Aguardando a concluso da impresso do Cupom..."))
        lret = MEGENCOM32_AguardaImpressao(PortaComunicacao, QuantosMilisegundos)
        If (lret <> 0) Then
            MsgBox("FALHA: Funo: [AguardaImpressao)] - Retorno: [" & Str(lret) & "]")
            AguardaImpressao = False
        End If
        System.Windows.Forms.Application.DoEvents()
    End Function
	
    Private Function StatusDoDispositivo() As Boolean
        Dim lret As Integer
        Dim bStatus As Byte

        StatusDoDispositivo = False

        ' Inicializa variaveis
        lbl_StatusDoDispositivo.Text = ""
        bStatus = 255

        chk_OnLine.CheckState = System.Windows.Forms.CheckState.Unchecked
        chk_ComErro.CheckState = System.Windows.Forms.CheckState.Unchecked
        chk_Busy.CheckState = System.Windows.Forms.CheckState.Unchecked
        chk_SemPapel.CheckState = System.Windows.Forms.CheckState.Unchecked

        lret = MEGENCOM32_StatusDoDispositivo(PortaComunicacao, bStatus)
        If (lret <> 0) Then
            MsgBox("FALHA: Funo: [StatusDoDispositivo()] - Retorno: [" & Str(lret) & "]")
            Exit Function
        End If

        lbl_StatusDoDispositivo.Text = CStr(bStatus)

        If Opt_PortaSerial.Checked = True Or Opt_PortaUSB.Checked = True Then
            If (bStatus And MASK_BIT7) <> 0 Then
                ' Impressora Busy
                chk_Busy.CheckState = System.Windows.Forms.CheckState.Checked
            Else
                ' Impressora Not Busy
                chk_Busy.CheckState = System.Windows.Forms.CheckState.Unchecked
            End If

            If (bStatus And MASK_BIT4) = 0 Then
                ' Impressora On Line
                chk_OnLine.CheckState = System.Windows.Forms.CheckState.Checked
            Else
                ' Impressora Off Line
                chk_OnLine.CheckState = System.Windows.Forms.CheckState.Unchecked
            End If

        ElseIf Opt_PortaParalela.Checked = True Then
            If (bStatus And MASK_BIT4) <> 0 Then
                ' Impressora On Line
                chk_OnLine.CheckState = System.Windows.Forms.CheckState.Checked
            Else
                ' Impressora Off Line
                chk_OnLine.CheckState = System.Windows.Forms.CheckState.Unchecked
            End If

            If (bStatus And MASK_BIT3) = 0 Then
                ' Impressora com Erro
                chk_ComErro.CheckState = System.Windows.Forms.CheckState.Checked
            Else
                ' Impressora Sem Erro
                chk_ComErro.CheckState = System.Windows.Forms.CheckState.Unchecked
            End If

            If (bStatus And MASK_BIT7) <> 0 Then
                ' Impressora Busy
                chk_Busy.CheckState = System.Windows.Forms.CheckState.Checked
            Else
                ' Impressora Not Busy
                chk_Busy.CheckState = System.Windows.Forms.CheckState.Unchecked
            End If

            If (bStatus And MASK_BIT5) <> 0 Then
                ' Impressora Sem Papel
                chk_SemPapel.CheckState = System.Windows.Forms.CheckState.Checked
            Else
                ' Impressora Com Papel
                chk_SemPapel.CheckState = System.Windows.Forms.CheckState.Unchecked
            End If
        End If

        StatusDoDispositivo = True
    End Function
	
	'-----------------------------------------------------------------------------------------------
	
    Private Function EscreverByteStatus(ByVal Tipo As Short) As Boolean
        Dim bBuffer As String

        EscreverByteStatus = False

        ' Monta o comando adequado
        If Tipo = StatusTipoPapel Then
            bBuffer = CmdStatusTipoPapel
        ElseIf Tipo = StatusTipoGenerico Then
            bBuffer = CmdStatusTipoGenerico
        Else
            Exit Function
        End If

        'Envia a solicitacao de status
        If EscreverNaPorta(bBuffer, TamCmdStatus, AguardarQtosMs) = False Then
            Exit Function
        End If

        EscreverByteStatus = True
    End Function
	
	Private Function AguardaByteStatus(ByVal Tipo As Short, ByVal QuantosMilisegundos As Integer, ByRef bByte As Byte) As Boolean
		Dim inicio As Integer

		'Inicializa contator
		inicio = GetTickCount()
		
		'Byte invlido
		AguardaByteStatus = False
		
		'Aguarda resposta do status (em Milisegundos)
		Dim bBuffer As String
		Dim TamLido As Integer
		Do While GetTickCount() < inicio + QuantosMilisegundos
			
			bBuffer = ""
			
            If LeraPorta(bBuffer, 1, TamLido) = False Then
                Exit Function
            End If
			
			If TamLido > 0 Then
				bByte = Asc(Mid(bBuffer, 1))
				
				'Confirma se o byte lido realmente se refere ao status solicitado
				If Tipo = StatusTipoPapel Then
					If (bByte And MASK_BIT5) = MASK_BIT5 And (bByte And MASK_BIT6) = 0 Then
						AguardaByteStatus = True
						Exit Function
					End If
				ElseIf Tipo = StatusTipoGenerico Then 
					If (bByte And MASK_BIT5) = 0 And (bByte And MASK_BIT6) = MASK_BIT6 Then
						AguardaByteStatus = True
						Exit Function
					End If
				End If
				
				MsgBox("Chegou byte: [" & Str(bByte) & "] - Mas no  o esperado!")
			End If
		Loop 
	End Function

    Private Sub LimpaTela_StatusTipoPapel()
        ' Status do Papel e Cabeca
        chk_StatusPapelAutomatico.CheckState = System.Windows.Forms.CheckState.Unchecked 'Bit 7
        chk_StatusPapelSempre0.CheckState = System.Windows.Forms.CheckState.Unchecked 'Bit 6 = 0
        chk_StatusPapelSempre1.CheckState = System.Windows.Forms.CheckState.Unchecked 'Bit 5 = 1
        chk_TensaoVH.CheckState = System.Windows.Forms.CheckState.Unchecked 'Bit 4
        chk_TemperaturaAcima.CheckState = System.Windows.Forms.CheckState.Unchecked 'Bit 3
        chk_CabecaLevantada.CheckState = System.Windows.Forms.CheckState.Unchecked 'Bit 2
        chk_StatusFimPapel.CheckState = System.Windows.Forms.CheckState.Unchecked 'Bit 1
        chk_StatusPoucoPapel.CheckState = System.Windows.Forms.CheckState.Unchecked 'Bit 0

        chk_StatusPapelAutomatico.Font = VB6.FontChangeBold(chk_StatusPapelAutomatico.Font, False)
        chk_StatusPapelSempre0.Font = VB6.FontChangeBold(chk_StatusPapelSempre0.Font, False)
        chk_StatusPapelSempre1.Font = VB6.FontChangeBold(chk_StatusPapelSempre1.Font, False)
        chk_TensaoVH.Font = VB6.FontChangeBold(chk_TensaoVH.Font, False)
        chk_TemperaturaAcima.Font = VB6.FontChangeBold(chk_TemperaturaAcima.Font, False)
        chk_CabecaLevantada.Font = VB6.FontChangeBold(chk_CabecaLevantada.Font, False)
        chk_StatusFimPapel.Font = VB6.FontChangeBold(chk_StatusFimPapel.Font, False)
        chk_StatusPoucoPapel.Font = VB6.FontChangeBold(chk_StatusPoucoPapel.Font, False)
    End Sub

    Private Function Recebe_StatusTipoPapel() As Boolean
        Dim bByte As Byte

        Recebe_StatusTipoPapel = True

        lbl_StatusTipoPapel.Text = ""

        'Aguarda por no mximo 5 segundos a resposta da solicitao de status do tipo papel
        If AguardaByteStatus(StatusTipoPapel, 5000, bByte) = False Then
            MsgBox("FALHA: Funo: [Recebe_StatusTipoPapel()] - 0 (zero) bytes lidos.")
            Recebe_StatusTipoPapel = False
            Exit Function
        End If

        lbl_StatusTipoPapel.Text = CStr(bByte)

        ' Verifica se Pouco Papel
        If (bByte And MASK_BIT0) = MASK_BIT0 Then
            chk_StatusPoucoPapel.CheckState = System.Windows.Forms.CheckState.Checked
        End If

        ' Verifica se Fim de Papel
        If (bByte And MASK_BIT1) = MASK_BIT1 Then
            chk_StatusFimPapel.CheckState = System.Windows.Forms.CheckState.Checked
        End If

        ' Verifica se Cabeca Termica Levantada
        If (bByte And MASK_BIT2) = MASK_BIT2 Then
            chk_CabecaLevantada.CheckState = System.Windows.Forms.CheckState.Checked
        End If

        ' Verifica se Temperatura cabeca acima do limite
        If (bByte And MASK_BIT3) = MASK_BIT3 Then
            chk_TemperaturaAcima.CheckState = System.Windows.Forms.CheckState.Checked
        End If

        ' Verifica se tensao VH fora do range
        If (bByte And MASK_BIT4) = MASK_BIT4 Then
            chk_TensaoVH.CheckState = System.Windows.Forms.CheckState.Checked
        End If

        ' Sempre 1
        If (bByte And MASK_BIT5) = MASK_BIT5 Then
            chk_StatusPapelSempre1.CheckState = System.Windows.Forms.CheckState.Checked
        End If

        ' Sempre 0
        If (bByte And MASK_BIT6) = MASK_BIT6 Then
            chk_StatusPapelSempre0.CheckState = System.Windows.Forms.CheckState.Checked
        End If

    End Function
    Private Function Trata_StatusTipoPapel() As Boolean
        Trata_StatusTipoPapel = True

        ' Verifica se Pouco Papel
        If (chk_StatusPoucoPapel.CheckState = System.Windows.Forms.CheckState.Checked) Then
            chk_StatusPoucoPapel.Font = VB6.FontChangeBold(chk_StatusPoucoPapel.Font, True)
        End If

        ' Verifica se Fim de Papel
        If (chk_StatusFimPapel.CheckState = System.Windows.Forms.CheckState.Checked) Then
            chk_StatusFimPapel.Font = VB6.FontChangeBold(chk_StatusFimPapel.Font, True)
            Trata_StatusTipoPapel = False
        End If

        ' Verifica se Cabeca Termica Levantada
        If (chk_CabecaLevantada.CheckState = System.Windows.Forms.CheckState.Checked) Then
            chk_CabecaLevantada.Font = VB6.FontChangeBold(chk_CabecaLevantada.Font, True)
            Trata_StatusTipoPapel = False
        End If

        ' Verifica se Temperatura cabeca acima do limite
        If (chk_TemperaturaAcima.CheckState = System.Windows.Forms.CheckState.Checked) Then
            chk_TemperaturaAcima.Font = VB6.FontChangeBold(chk_TemperaturaAcima.Font, True)
            Trata_StatusTipoPapel = False
        End If

        ' Verifica se tensao VH fora do range
        If (chk_TensaoVH.CheckState = System.Windows.Forms.CheckState.Checked) Then
            chk_TensaoVH.Font = VB6.FontChangeBold(chk_TensaoVH.Font, True)
            Trata_StatusTipoPapel = False
        End If
    End Function

    Private Function EnviaTrata_StatusTipoPapel() As Boolean
        EnviaTrata_StatusTipoPapel = False

        'Desmarca e tira negrito de todos os status do tipo papel
        LimpaTela_StatusTipoPapel()

        'Limpa todos os bytes pendentes
        If LimparLeituraPorta() = False Then
            Exit Function
        End If

        ' Escreve o comando para solicitar status do tipo papel
        If EscreverByteStatus(StatusTipoPapel) = False Then
            Exit Function
        End If

        'Aguarda a impressora preparar a resposta
        Call AguardarMilisegundos(MiliSegPrepararStatus)

        'Recebe o status do tipo papel
        If Recebe_StatusTipoPapel() = False Then
            Exit Function
        End If

        'Faz a validao (tratamento) do status tipo papel
        If Trata_StatusTipoPapel() = False Then
            Exit Function
        End If

        EnviaTrata_StatusTipoPapel = True
    End Function
    Private Sub LimpaTela_StatusTipoGenerico()
        ' Status do Generico
        chk_StatusGenericoAutomatico.CheckState = System.Windows.Forms.CheckState.Unchecked 'Bit 7
        chk_StatusGenericoSempre1.CheckState = System.Windows.Forms.CheckState.Unchecked 'Bit 6 = 1
        chk_StatusGenericoSempre0.CheckState = System.Windows.Forms.CheckState.Unchecked 'Bit 5 = 0
        chk_FalhaInterna.CheckState = System.Windows.Forms.CheckState.Unchecked 'Bit 4
        chk_BufferRecepcaoVazio.CheckState = System.Windows.Forms.CheckState.Unchecked 'Bit 3
        chk_BufferRecepcaoCheio.CheckState = System.Windows.Forms.CheckState.Unchecked 'Bit 2
        chk_SensorGaveta.CheckState = System.Windows.Forms.CheckState.Unchecked 'Bit 1
        chk_TampaAberta.CheckState = System.Windows.Forms.CheckState.Unchecked 'Bit 0

        chk_StatusGenericoAutomatico.Font = VB6.FontChangeBold(chk_StatusGenericoAutomatico.Font, False)
        chk_StatusGenericoSempre1.Font = VB6.FontChangeBold(chk_StatusGenericoSempre1.Font, False)
        chk_StatusGenericoSempre0.Font = VB6.FontChangeBold(chk_StatusGenericoSempre0.Font, False)
        chk_FalhaInterna.Font = VB6.FontChangeBold(chk_FalhaInterna.Font, False)
        chk_BufferRecepcaoVazio.Font = VB6.FontChangeBold(chk_BufferRecepcaoVazio.Font, False)
        chk_BufferRecepcaoCheio.Font = VB6.FontChangeBold(chk_BufferRecepcaoCheio.Font, False)
        chk_SensorGaveta.Font = VB6.FontChangeBold(chk_SensorGaveta.Font, False)
        chk_TampaAberta.Font = VB6.FontChangeBold(chk_TampaAberta.Font, False)
    End Sub

    Private Function Recebe_StatusTipoGenerico() As Boolean
        Dim bByte As Byte

        Recebe_StatusTipoGenerico = True

        lbl_StatusTipoGenerico.Text = ""

        'Aguarda por no mximo 5 segundos a resposta da solicitao de status do tipo generico
        If AguardaByteStatus(StatusTipoGenerico, 5000, bByte) = False Then
            MsgBox("FALHA: Funo: [Recebe_StatusTipoGenerico()] - 0 (zero) bytes lidos.")
            Recebe_StatusTipoGenerico = False
            Exit Function
        End If

        lbl_StatusTipoGenerico.Text = CStr(bByte)

        ' Verifica se Tampa Aberta
        If (bByte And MASK_BIT0) = MASK_BIT0 Then
            chk_TampaAberta.CheckState = System.Windows.Forms.CheckState.Checked
        End If

        ' Verifica Sensor da Gaveta
        If (bByte And MASK_BIT1) = MASK_BIT1 Then
            chk_SensorGaveta.CheckState = System.Windows.Forms.CheckState.Checked
        End If

        ' Verifica se Buffer recepcao esta cheio
        If (bByte And MASK_BIT2) = MASK_BIT2 Then
            chk_BufferRecepcaoCheio.CheckState = System.Windows.Forms.CheckState.Checked
        End If

        ' Verifica se Buffer recepcao vazio
        If (bByte And MASK_BIT3) = MASK_BIT3 Then
            chk_BufferRecepcaoVazio.CheckState = System.Windows.Forms.CheckState.Checked
        End If

        ' Verifica se Falha interna
        If (bByte And MASK_BIT4) = MASK_BIT4 Then
            chk_FalhaInterna.CheckState = System.Windows.Forms.CheckState.Checked
        End If

        ' Sempre 0
        If (bByte And MASK_BIT5) = MASK_BIT5 Then
            chk_StatusGenericoSempre0.CheckState = System.Windows.Forms.CheckState.Checked
        End If

        ' Sempre 1
        If (bByte And MASK_BIT6) = MASK_BIT6 Then
            chk_StatusGenericoSempre1.CheckState = System.Windows.Forms.CheckState.Checked
        End If
    End Function
    Private Function Trata_StatusTipoGenerico() As Boolean
        Trata_StatusTipoGenerico = True

        ' Tampa Aberta
        If (chk_TampaAberta.CheckState = System.Windows.Forms.CheckState.Checked) Then
            chk_TampaAberta.Font = VB6.FontChangeBold(chk_TampaAberta.Font, True)
            Trata_StatusTipoGenerico = False
        End If

        ' Sensor da Gaveta
        If (chk_SensorGaveta.CheckState = System.Windows.Forms.CheckState.Checked) Then
            chk_SensorGaveta.Font = VB6.FontChangeBold(chk_SensorGaveta.Font, True)
        End If

        ' Buffer recepcao esta cheio
        If (chk_BufferRecepcaoCheio.CheckState = System.Windows.Forms.CheckState.Checked) Then
        End If

        ' Buffer recepcao esta vazio
        If (chk_BufferRecepcaoVazio.CheckState = System.Windows.Forms.CheckState.Checked) Then
        End If

        ' Falha interna
        If (chk_FalhaInterna.CheckState = System.Windows.Forms.CheckState.Checked) Then
            chk_FalhaInterna.Font = VB6.FontChangeBold(chk_FalhaInterna.Font, True)
            Trata_StatusTipoGenerico = False
        End If

    End Function
    Private Function EnviaTrata_StatusTipoGenerico() As Boolean
        EnviaTrata_StatusTipoGenerico = False

        'Desmarca e tira negrito de todos os status do tipo generico
        LimpaTela_StatusTipoGenerico()

        'Limpa todos os bytes pendentes
        If LimparLeituraPorta() = False Then
            Exit Function
        End If

        ' Escreve o comando para solicitar status do tipo generico
        If EscreverByteStatus(StatusTipoGenerico) = False Then
            Exit Function
        End If

        'Aguarda a impressora preparar a resposta
        Call AguardarMilisegundos(MiliSegPrepararStatus)

        'Recebe o status do tipo generico
        If Recebe_StatusTipoGenerico() = False Then
            Exit Function
        End If

        'Faz a validao (tratamento) do status tipo generico
        If Trata_StatusTipoGenerico() = False Then
            Exit Function
        End If

        EnviaTrata_StatusTipoGenerico = True
    End Function
    Private Function VerificaTodosStatus() As Boolean
        VerificaTodosStatus = True

        ' Solicita, recebe e trata  o status do tipo Papel
        If EnviaTrata_StatusTipoPapel() = False Then
            VerificaTodosStatus = False
        End If

        ' Solicita, recebe e trata  o status do tipo generico
        If EnviaTrata_StatusTipoGenerico() = False Then
            VerificaTodosStatus = False
        End If

    End Function

    Private Function Imprime_Cupom() As Boolean
        Dim bBuffer As String
        Dim TamBuffer As Integer
        Dim Cont As Short
        Dim Grafico As String
        Dim TamCodigo As Short
        Dim marg As String
        Dim larg As String
        Dim alt As Short
        Dim n1 As Byte
        Dim n2 As Byte
        Dim dotline As String
        Dim TamGrafico As Short

        Imprime_Cupom = False

        'Inicializa variaveis
        bBuffer = ""
        TamBuffer = 0

        ' Atributos
        Dim cmdQRCode_Cabec As String
        Dim Tam_Cabec As Short
        Dim cmdQRCode_ECC15 As String
        Dim Tam_ECC As Short
        Dim ECC_Escolhido As Byte
        Dim cmdQRCode_Larg As String
        Dim Tam_Larg As Short
        Dim QRCode_Larg As Byte
        Dim cmdQRCode_Dados As String
        Dim Tam_Dados As Short
        Dim cmdQRCode_Fim As String
        Dim Tam_Fim As Short
        Dim sArq As String
        If Opt_CupomComAtributos.Checked = True Then
            If Chk_TodosAtributos.CheckState = System.Windows.Forms.CheckState.Checked Then
                bBuffer = bBuffer & cmdAtivaNegrito & "Negrito (enfatizado)." & cmdDesativaNegrito & Chr(10)
                TamBuffer = TamBuffer + Tam_cmdAtivaNegrito + Len("Negrito (enfatizado).") + Tam_cmdDesativaNegrito + 1

                bBuffer = bBuffer & cmdAtivaExpandido & "Expandido." & cmdDesativaExpandido & Chr(10)
                TamBuffer = TamBuffer + Tam_cmdAtivaExpandido + Len("Expandido.") + Tam_cmdDesativaExpandido + 1

                bBuffer = bBuffer & cmdAtivaCondensado & "Condensado." & cmdDesativaCondensado & Chr(10)
                TamBuffer = TamBuffer + Tam_cmdAtivaCondensado + Len("Condensado.") + Tam_cmdDesativaCondensado + 1

                bBuffer = bBuffer & cmdAtivaSublinhado & "Sublinhado." & cmdDesativaSublinhado & Chr(10)
                TamBuffer = TamBuffer + Tam_cmdAtivaSublinhado + Len("Sublinhado.") + Tam_cmdDesativaSublinhado + 1

                bBuffer = bBuffer & cmdAtivaItalico & "Italico." & cmdDesativaItalico & Chr(10)
                TamBuffer = TamBuffer + Tam_cmdAtivaItalico + Len("Italico.") + Tam_cmdDesativaItalico + 1

                bBuffer = bBuffer & cmdAtivaCondensado & cmdAtivaSublinhado & "Condensado & Sublinhado." & cmdDesativaTodosAtributos & Chr(10)
                TamBuffer = TamBuffer + Tam_cmdAtivaCondensado + Tam_cmdAtivaSublinhado + Len("Condensado & Sublinhado.") + Tam_cmdDesativaTodosAtributos + 1

                bBuffer = bBuffer & cmdAtivaItalico & cmdAtivaExpandido & "Expandido &  Italico." & cmdDesativaTodosAtributos & Chr(10)
                TamBuffer = TamBuffer + Tam_cmdAtivaItalico + Tam_cmdAtivaExpandido + Len("Expandido &  Italico.") + Tam_cmdDesativaTodosAtributos + 1
            Else
                If Chk_Negrito.CheckState = System.Windows.Forms.CheckState.Checked Then
                    bBuffer = bBuffer & cmdAtivaNegrito
                    TamBuffer = TamBuffer + Tam_cmdAtivaNegrito
                End If
                If Chk_Italico.CheckState = System.Windows.Forms.CheckState.Checked Then
                    bBuffer = bBuffer & cmdAtivaItalico
                    TamBuffer = TamBuffer + Tam_cmdAtivaItalico
                End If
                If Chk_Sublinhado.CheckState = System.Windows.Forms.CheckState.Checked Then
                    bBuffer = bBuffer & cmdAtivaSublinhado
                    TamBuffer = TamBuffer + Tam_cmdAtivaSublinhado
                End If
                If Chk_Expandido.CheckState = System.Windows.Forms.CheckState.Checked Then
                    bBuffer = bBuffer & cmdAtivaExpandido
                    TamBuffer = TamBuffer + Tam_cmdAtivaExpandido
                End If
                If Chk_Condensado.CheckState = System.Windows.Forms.CheckState.Checked Then
                    bBuffer = bBuffer & cmdAtivaCondensado
                    TamBuffer = TamBuffer + Tam_cmdAtivaCondensado
                End If
            End If

            bBuffer = bBuffer & TXT_Impressao.Text & cmdDesativaTodosAtributos & Chr(10)
            TamBuffer = TamBuffer + Len(TXT_Impressao.Text) + Tam_cmdDesativaTodosAtributos + 1

            'No exemplo abaixo so enviados 1000 bytes do tipo 0xFF para imprimir uma
            'barra preta de 25 mm de largura, 5 mm de altura e 10 mm de margem.
            'OBS: considere 1mm = 8 dots => 200 dots de largura, 40 dotlines de altura, 80 dots de margem
            'O desenho dever ser montado considerando uma seqncia de bits 1 e 0,
            'onde o bit 1  a informao que ser impressa.
            'O byte 0xFF representa 11111111 (8 bits 1), portanto ser impresso
            'uma linha preta. O byte 0xAA representa 10101010, portanto se fizesse
            'parte do grfico imprimiria uma pequena poro pontilhada onde o
            'caracter 0xAA fosse inserido.
            'Sintaxe do comando:
            '<ESC> 'n' <marg> <larg> <n1> <n2> <dotline>
            '<marg> = Para margem 10 mm (80 dots), deve ser informado: 10 (10*8dots=80).
            '<larg> = Largura de 25mm (200 dots), deve ser informado: 25 (200/8=25), representando o nmero de bytes por linha (dot line).
            '<n1> = Resto da diviso da altura por 256, deve ser informado: 40 (40-(n2*256)=40)
            '<n2> = Quociente da diviso da altura por 256, deve ser informado: 0 (40/256=0)
            '<dotline> = So os bytes que representam o grfico a ser impresso, nesse exemplo seriam 1000 bytes (<larg>*40 = 25*40 = 1000 bytes).
            'chr(27) + n + Chr(10) + chr(25) +  chr(40)  + chr(0) + <1000 bytes>
            'OBS:
            '1) Caso tenha dvidas, utilize o modo HEX DUMP para saber os bytes que a
            'impressora est recebendo.
            '2) O comando grfico possui um cabealho que indica quantos bytes compe
            'o bitmap. Se os bytes enviados estiverem fora do informado no cabealho,
            'o comportamento da impressora ser imprevisvel. Os sintomas mais comuns
            'so travamento (a impressora no recebeu todos os bytes informados
            'no cabealho e fica num estado de espera para completar o comando
            'grfico) e impresso de sujeira (o cabealho est informando um
            'grfico maior que o nmero de bytes que compe o grfico. Nesse caso,
            'a impressora ir tratar os bytes seguintes como comando grfico,
            'bytes que o aplicativo gostaria que fossem tratados como modo texto ou
            'seqncias de ESC).


            ' Preenchendo a margem e largura
            marg = Chr(10)
            larg = Chr(25)

            ' Calculando o nmero de bytes (colunas grficas)
            alt = 40
            n2 = (alt / 256)
            n1 = (alt Mod 256)

            ' Montando o comando
            Grafico = Chr(27) & "n"
            'Concatenando a margem e largura
            Grafico = Grafico & marg & larg
            ' Concatenando o n1
            Grafico = Grafico & Chr(n1)
            ' Concatenando o n2
            Grafico = Grafico & Chr(Int(n2))

            ' Montando o grfico
            dotline = ""
            Cont = 0
            While Cont < 1000
                Cont = Cont + 1
                dotline = dotline & Chr(255)
            End While

            ' Concatenando o comando e os bytes do grfico (colunas grficas)
            Grafico = Grafico & dotline
            ' 6 bytes do cabealho (ESC + "n" + marg + larg + n1 + n2) +  bytes do grfico
            TamGrafico = 6 + Cont

            ' Concatenando o grafico aos dados que j estavam armazenados em bBuffer
            bBuffer = bBuffer & Grafico

            ' Calculando o tamanho do buffer a ser impresso
            TamBuffer = TamBuffer + TamGrafico

            ' Codigo de Barras
        ElseIf Opt_CodigoDeBarras.Checked = True Then

            'Posicao do codigo numerico
            If (Chk_CodAcima.CheckState = System.Windows.Forms.CheckState.Unchecked) And (Chk_CodAbaixo.CheckState = System.Windows.Forms.CheckState.Unchecked) Then
                PosicaoCodNumerico = 0
            ElseIf (Chk_CodAcima.CheckState = System.Windows.Forms.CheckState.Checked) And (Chk_CodAbaixo.CheckState = System.Windows.Forms.CheckState.Unchecked) Then
                PosicaoCodNumerico = 1
            ElseIf (Chk_CodAcima.CheckState = System.Windows.Forms.CheckState.Unchecked) And (Chk_CodAbaixo.CheckState = System.Windows.Forms.CheckState.Checked) Then
                PosicaoCodNumerico = 2
            ElseIf (Chk_CodAcima.CheckState = System.Windows.Forms.CheckState.Checked) And (Chk_CodAbaixo.CheckState = System.Windows.Forms.CheckState.Checked) Then
                PosicaoCodNumerico = 3
            End If

            'Calcula o tamanho do texto que ser convertido em barras
            TamCodigo = Len(TXT_Impressao.Text)

            'Tipo de codigo de barras
            If Opt_CodBarras2de5.Checked = True Then
                bBuffer = cmdIntercalados2e5 & Chr(PosicaoCodNumerico) & Chr(TamCodigo) & TXT_Impressao.Text
                TamBuffer = TamCmdCodBarras + 1 + 1 + TamCodigo
            ElseIf Opt_CodBarrasCode39.Checked = True Then
                bBuffer = cmdCODE39 & Chr(PosicaoCodNumerico) & Chr(TamCodigo) & TXT_Impressao.Text
                TamBuffer = TamCmdCodBarras + 1 + 1 + TamCodigo
            ElseIf Opt_CodBarrasEAN8.Checked = True Then
                bBuffer = cmdEAN8 & Chr(PosicaoCodNumerico) & TXT_Impressao.Text
                TamBuffer = TamCmdCodBarras + 1 + TamCodigo
            ElseIf Opt_CodBarrasEAN13.Checked = True Then
                bBuffer = cmdEAN13 & Chr(PosicaoCodNumerico) & TXT_Impressao.Text
                TamBuffer = TamCmdCodBarras + 1 + TamCodigo
            ElseIf Opt_CodBarrasCode128.Checked = True Then
                bBuffer = cmdCode128 & Chr(PosicaoCodNumerico) & Chr(TamCodigo) & TXT_Impressao.Text
                TamBuffer = TamCmdCodBarras + 1 + 1 + TamCodigo
            End If


            ' QRCode
        ElseIf Opt_CodBarrasQRCode.Checked = True Then
            '''''''''''''''''''''''''''''''''''''''''''''''''''
            ' Montando o comando QRCode
            ''''''''''''''''''''''''''''''''''''''''''''''''''

            ' Montanto o comando cabealho
            cmdQRCode_Cabec = Chr(&H1B) & Chr(&H28) & Chr(&H6B) ' cabealho
            Tam_Cabec = 3

            ' Selecionando nvel de correo de erro (ECC)
            'Programa o nvel de correo de erro (ECC):
            '<error> Nvel Capacidade de Correo
            '0 ou 0(30h/48) L 7%
            '1 ou 1(31h/49) M 15%
            '2 ou 2(32h/50) Q 25%
            '3 ou 3(33h/51) H 30%
            'Valor inicial programado L, 7% de correo.


            If cmb_ECC_Escolhido.SelectedIndex = 0 Then
                ECC_Escolhido = Asc("0") ' L 7% = 0 ou 0(30h/48)
            ElseIf cmb_ECC_Escolhido.SelectedIndex = 1 Then
                ECC_Escolhido = Asc("1") ' M 15% = 1 ou 1(31h/49)
            ElseIf cmb_ECC_Escolhido.SelectedIndex = 2 Then
                ECC_Escolhido = Asc("2") ' Q 25% = 2 ou 2(32h/50)
            Else
                ECC_Escolhido = Asc("3") ' H 30% = 3 ou 3(33h/51)
            End If

            ' cabealho + <n1> + <n2> + comando ECC (31h 45h) + valor tabela de ECC 15% (31h)
            cmdQRCode_ECC15 = cmdQRCode_Cabec & Chr(&H3) & Chr(&H0) & Chr(&H31) & Chr(&H45) & Chr(ECC_Escolhido)
            Tam_ECC = Tam_Cabec + 5

            ' Selecionando a maior largura para o cdigo
            'Programa a largura de cada mdulo em mltiplos de 0.125mm.
            'Para bobina de 76mm, 80mm ou 57mm, a largura mxima  19, para boa
            'qualidade de impresso e boa taxa de leitura, sugere-se utilizar largura 2 ou
            '3.
            'Valor inicial programado 0, que indica selecionar maior largura para o
            'cdigo.

            ' Selecionando a maior largura para o cdigo

            If (CDbl(Edit_QRCode_Larg.Text) > 19) Then
                TXT_Impressao.Text = "Largura mx: 19 (bobinas de 76/80/57mm). Para boa impresso e leitura, sugere-se largura 2 ou 3."
                Exit Function
            End If

            QRCode_Larg = CByte(Edit_QRCode_Larg.Text)

            ' cabealho + <n1> + <n2> + comando Largura (31h + 44h) + valor largura do cdigo (05h)
            cmdQRCode_Larg = cmdQRCode_Cabec & Chr(&H3) & Chr(&H0) & Chr(&H31) & Chr(&H43) & Chr(QRCode_Larg)
            Tam_Larg = Tam_Cabec + 5

            ' Selecionando os dados para o cdigo

            ' Ateno: Nesse comando, muda o significado do n1 e n2!
            ' cabealho + <n1> + <n2> + comando Prog Dados do Cdigo (31h 50h 30h) + Dados do cdigo
            ' Sendo 'k' = Quantidade de dados do cdigo + 3, nesse caso (17+3) = 20
            ' Pode-se chegar em <n1> e <n2> da seguinte forma:
            ' k/256 = <n2>
            ' k%256 = <n1>
            ' 20/256 = 0 = 00h <n2>
            ' 20%256 = 20 = 14h <n1>
            n2 = Fix((StrQRCode_Tam + 3) / 256)
            n1 = (StrQRCode_Tam + 3) Mod 256

            cmdQRCode_Dados = cmdQRCode_Cabec & Chr(n1) & Chr(n2) & Chr(&H31) & Chr(&H50) & Chr(&H30) & StrQRCode_Dados
            Tam_Dados = Tam_Cabec + 5 + StrQRCode_Tam

            ' Para finalizar a impressao
            ' cabealho + <n1> + <n2> + comando imprime (fim) (31h + 51h + 30h)
            cmdQRCode_Fim = cmdQRCode_Cabec & Chr(&H3) & Chr(&H0) & Chr(&H31) & Chr(&H51) & Chr(&H30)
            Tam_Fim = Tam_Cabec + 5

            ' Montando a sequencia completa
            cmdQRCode = cmdQRCode_ECC15 & cmdQRCode_Larg & cmdQRCode_Dados & cmdQRCode_Fim
            TamCmdQRCode = Tam_ECC + Tam_Larg + Tam_Dados + Tam_Fim
            '''''''''''''''''''''''''''''''''''''''''''''''''''
            ' Final do QRCode
            '''''''''''''''''''''''''''''''''''''''''''''''''''

            bBuffer = cmdQRCode
            TamBuffer = TamCmdQRCode

            ' Impresso simples
        ElseIf Opt_CupomSimples.Checked = True Then

            ' Montando o cupom a ser impresso
            For Cont = 1 To CInt(Edit_NLinhas.Text)
                bBuffer = bBuffer & "Linha " & Cont & Chr(10)
            Next

            ' Calculando o tamanho do buffer a ser impresso
            TamBuffer = Len(bBuffer)

            ' Impresso de Arquivo
        ElseIf Opt_ImprimirDeArquivo.Checked = True Then

            ' Verifica se o arquivo foi selecionado
            If FileListBox.FileName = "" Then
                MsgBox("FALHA: [Imprime_Cupom()] - Selecione um arquivo.")
                Exit Function
            End If

            ' Monta a pasta e nome do arquivo
            sArq = FileListBox.Path & "\" & FileListBox.FileName
            If ImprimeDeArquivo(sArq) = False Then
                Exit Function
            End If

            Imprime_Cupom = True

            Exit Function
        Else
            ExibeMsgErro(("Escolha um tipo de impresso."))
            Exit Function
        End If

        ' Envia os bytes a serem impressos
        If EscreverNaPorta(bBuffer, TamBuffer, AguardarQtosMs) = False Then
            Exit Function
        End If

        Imprime_Cupom = True
    End Function
    Private Function ImprimeDeArquivo(ByVal NomeArq As String) As Boolean
        Dim bBuffer As String
        Dim TamBuffer As Long

        If chSemBlocos.Checked = True Then
            ImprimeDeArquivo = True

            NomeArq = FileListBox.Path & "\" & FileListBox.FileName

            ' Abre arquivo
            FileOpen(1, NomeArq, OpenMode.Binary, OpenAccess.Read, OpenShare.LockRead)

            TamBuffer = LOF(1)

            ' Lendo conteudo do arquivo para a variavel "bBuffer"
            bBuffer = InputString(1, TamBuffer)

            ' Envia os bytes a serem impressos
            If EscreverNaPorta(bBuffer, TamBuffer, AguardarQtosMs) = False Then
                ImprimeDeArquivo = False
                '    Exit Do
            End If
            ' Fecha o arquivo
            FileClose(1)
        Else
            Dim PosArqAtual As Long
            Dim PosArqAnt As Long

            ImprimeDeArquivo = True

            NomeArq = FileListBox.Path & "\" & FileListBox.FileName

            ' Abre arquivo
            FileOpen(1, NomeArq, OpenMode.Binary, OpenAccess.Read, OpenShare.LockRead)

            ' Inicializa a posicao anterior do ponteiro do arquivo
            PosArqAnt = 0

            Do
                ' Lendo conteudo do arquivo para a variavel "bBuffer" (em blocos)
                ' O contedo do arquivo ser enviado em blocos de "TamBlocosLeituraArq"
                bBuffer = InputString(1, TamBlocosLeituraArq)

                ' L a posio do ponteiro no arquivo
                PosArqAtual = Loc(1)

                ' Calculando o tamanho do buffer (numero de bytes lidos):
                ' Como o arquivo pode conter o caracter 0x00 (Null terminador),
                ' no podemos usar a funo Len(bBuffer) para obter o tamanho do buffer (numero de bytes lidos).
                ' A funo Loc() retorna a posio atual do ponteiro no arquivo, e
                ' se tivermos a posio anterior, podemos calcular o tamanho do buffer (numero de bytes lidos).
                TamBuffer = PosArqAtual - PosArqAnt

                ' Envia os bytes a serem impressos
                If EscreverNaPorta(bBuffer, TamBuffer, AguardarQtosMs) = False Then
                    ImprimeDeArquivo = False
                    Exit Do
                End If

                ' Salva a ultima posicao do ponteiro no arquivo
                PosArqAnt = PosArqAtual

            Loop Until EOF(1) = True ' Executa at encontrar o final do arquivo

            ' Fecha o arquivo
            FileClose(1)
        End If

    End Function

    Private Function Corta_Papel() As Boolean
        Corta_Papel = False

        ' Enviando comando de corte
        If EscreverNaPorta(cmdCortePapel, Tam_cmdCortePapel, AguardarQtosMs) = False Then
            Exit Function
        End If

        Corta_Papel = True
    End Function
    Private Function PulsoDeGaveta() As Boolean
        PulsoDeGaveta = False

        ' Enviando comando para acionar gaveta
        If EscreverNaPorta(cmdPulsoGaveta, Tam_cmdPulsoGaveta, AguardarQtosMs) = False Then
            Exit Function
        End If

        PulsoDeGaveta = True
    End Function
    '-----------------------------------------------------------------------------------------------

    '--------------------------------- Tratamento de mensagens -------------------------------------

    Private Sub ExibeMsgErro(ByRef msg As String)
        TXT_Mensagem.ForeColor = System.Drawing.ColorTranslator.FromOle(QBColor(4)) 'Cor da Fonte: Vermelho
        TXT_Mensagem.BackColor = System.Drawing.ColorTranslator.FromOle(QBColor(15)) 'Cor da Fundo: Branco
        TXT_Mensagem.Text = msg
        System.Windows.Forms.Application.DoEvents()
    End Sub

    Private Sub ExibeMsgAguarde(ByRef msg As String)
        TXT_Mensagem.ForeColor = System.Drawing.ColorTranslator.FromOle(QBColor(0)) ' Cor da Fonte: Preta
        TXT_Mensagem.BackColor = System.Drawing.ColorTranslator.FromOle(QBColor(10)) ' Cor da Fundo: Verde
        TXT_Mensagem.Text = msg
        System.Windows.Forms.Application.DoEvents()
    End Sub

    Private Sub ExibeMsgConclusao(ByRef msg As String)
        TXT_Mensagem.ForeColor = System.Drawing.ColorTranslator.FromOle(QBColor(9)) ' Cor da Fonte: Azul
        TXT_Mensagem.BackColor = System.Drawing.ColorTranslator.FromOle(QBColor(15)) ' Cor Fundo: Branco
        TXT_Mensagem.Text = msg
        System.Windows.Forms.Application.DoEvents()
    End Sub

    Private Sub ExibeMsgAcao(ByRef msg As String)
        TXT_Mensagem.ForeColor = System.Drawing.ColorTranslator.FromOle(QBColor(0)) ' Cor da Fonte: Preta
        TXT_Mensagem.BackColor = System.Drawing.ColorTranslator.FromOle(QBColor(14)) ' Cor do Fundo: Amarelo
        TXT_Mensagem.Text = msg
        System.Windows.Forms.Application.DoEvents()
    End Sub

    Private Sub Dirlistbox_Change(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Dirlistbox.Change
        FileListBox.Path = Dirlistbox.Path
    End Sub

    Private Sub FileListBox_SelectedIndexChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles FileListBox.SelectedIndexChanged
        lbl_NomeArquivo.Text = FileListBox.FileName
    End Sub

    Private Sub frm_Principal_Activated(sender As Object, e As EventArgs) Handles Me.Activated

    End Sub

    '-----------------------------------------------------------------------------------------------

    Private Sub frm_Principal_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
        If Mid(PortaComunicacao, 1, 3) = "COM" Then
            ' Interface Serial
            Opt_PortaSerial.Checked = True
        ElseIf Mid(PortaComunicacao, 1, 3) = "LPT" Then
            ' Interface Paralela
            Opt_PortaParalela.Checked = True
        ElseIf Mid(PortaComunicacao, 1, 3) = "USB" Then
            ' Interface USB
            Opt_PortaUSB.Checked = True
        Else
            ExibeMsgErro(("Escolha a interface de comunicao."))
            Exit Sub
        End If

        'Seleciona os valores padro(default) para serial:
        'Serial = COM1
        cmb_PortaSerial.SelectedIndex = 0 'COM1
        'Velocidade(bps)
        cmb_Velocidade.SelectedIndex = 3 '57600
        'Paridade
        cmb_Paridade.SelectedIndex = 2 'Nenhum
        'Bits de Dados
        cmb_BitDados.SelectedIndex = 0 '8
        'Bits de Parada
        cmb_BitParada.SelectedIndex = 0 '0
        'Controle de Fluxo (Protocolo)
        cmb_ControlFluxo.SelectedIndex = 1 'Hardware (CTS/RTS)

        'Paralela
        cmb_PortaParalela.SelectedIndex = 0 'LPT1

        ' Nenhum byte enviado
        NumBytesEnviados = 0

        ' Porta fechada por enquanto
        boPortaAberta = False

        ' Seleciona LOG de Todas as Camadas
        cmb_CamadaLOG.SelectedIndex = CAMADA_TODAS
        ' Seleciona nvel Maximo para LOG
        cmb_NivelDepuracaoLOG.SelectedIndex = MECAF_NIVELMSG_MAXIMO

        ' Configura os valores default de timeout de RX e TX
        txt_TimeoutRX.Text = CStr(ValorTimeOutRX)
        txt_TimeoutTX.Text = CStr(ValorTimeOutTX)

        ' Abre a porta de comunicacao
        If AbrirPorta() = True Then
            Call DesabilitaBotoesPortaComunicacao()
        End If


        ' Inicializa as variveis de comando
        Call InitVariavelCmd()
    End Sub
    Private Sub frm_Principal_FormClosed(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        ' Verifica se porta est aberta
        If boPortaAberta = True Then
            ExibeMsgAcao(("Fechando a porta..."))
            Call FecharPorta()
        End If
    End Sub


    Private Sub HabilitaBotoes()
        bt_TratamentoCompleto.Enabled = True
        bt_VerificaStatus.Enabled = True
        bt_PreparaImpressao.Enabled = True
        bt_ImprimeCupom.Enabled = True
        bt_AguardaImpressao.Enabled = True
        bt_AcionaGuilhotina.Enabled = True
        bt_AbreGaveta.Enabled = True
        bt_SolicitaStatusPapel.Enabled = True
        bt_SolicitaStatusGenerico.Enabled = True
        bt_Sair.Enabled = True
    End Sub

    Private Sub DesabilitaBotoes()
        bt_TratamentoCompleto.Enabled = False
        bt_VerificaStatus.Enabled = False
        bt_PreparaImpressao.Enabled = False
        bt_ImprimeCupom.Enabled = False
        bt_AguardaImpressao.Enabled = False
        bt_AcionaGuilhotina.Enabled = False
        bt_AbreGaveta.Enabled = False
        bt_SolicitaStatusPapel.Enabled = False
        bt_SolicitaStatusGenerico.Enabled = False
        bt_Sair.Enabled = False
    End Sub

    Private Sub DesabilitaBotoesPortaComunicacao()
        Opt_PortaSerial.Enabled = False
        Opt_PortaParalela.Enabled = False
        Opt_PortaUSB.Enabled = False
        cmb_Velocidade.Enabled = False
        cmb_Paridade.Enabled = False
        cmb_BitDados.Enabled = False
        cmb_BitParada.Enabled = False
        cmb_ControlFluxo.Enabled = False
        cmb_PortaSerial.Enabled = False
        cmb_PortaParalela.Enabled = False
        bt_AbrirPorta.Enabled = False
        bt_FecharPorta.Enabled = True
    End Sub

    Private Sub HabilitaBotoesPortaComunicacao()
        Opt_PortaSerial.Enabled = True
        Opt_PortaParalela.Enabled = True
        Opt_PortaUSB.Enabled = True
        cmb_Velocidade.Enabled = True
        cmb_Paridade.Enabled = True
        cmb_BitDados.Enabled = True
        cmb_BitParada.Enabled = True
        cmb_ControlFluxo.Enabled = True
        cmb_PortaSerial.Enabled = True
        cmb_PortaParalela.Enabled = True
        bt_AbrirPorta.Enabled = True
        bt_FecharPorta.Enabled = False
    End Sub
    Private Sub DesabilitaBotoesPortaComunicacaoUSB()
        bt_AbrirPorta.Enabled = False
        bt_FecharPorta.Enabled = True
    End Sub
    Private Sub HabilitaBotoesPortaComunicacaoUSB()
        bt_AbrirPorta.Enabled = True
        bt_FecharPorta.Enabled = False
    End Sub
    Private Sub DesabilitaBotoesPortaComunicacaoParalela()
        cmb_PortaParalela.Enabled = False
        bt_AbrirPorta.Enabled = False
        bt_FecharPorta.Enabled = True
    End Sub
    Private Sub HabilitaBotoesPortaComunicacaoParalela()
        cmb_PortaParalela.Enabled = True
        bt_AbrirPorta.Enabled = True
        bt_FecharPorta.Enabled = False
    End Sub
    Private Sub DesabilitaBotoesPortaComunicacaoSerial()
        cmb_Velocidade.Enabled = False
        cmb_Paridade.Enabled = False
        cmb_BitDados.Enabled = False
        cmb_BitParada.Enabled = False
        cmb_ControlFluxo.Enabled = False
        cmb_PortaSerial.Enabled = False
        bt_AbrirPorta.Enabled = False
        bt_FecharPorta.Enabled = True
    End Sub
    Private Sub HabilitaBotoesPortaComunicacaoSerial()
        cmb_Velocidade.Enabled = True
        cmb_Paridade.Enabled = True
        cmb_BitDados.Enabled = True
        cmb_BitParada.Enabled = True
        cmb_ControlFluxo.Enabled = True
        cmb_PortaSerial.Enabled = True
        bt_AbrirPorta.Enabled = True
        bt_FecharPorta.Enabled = False
    End Sub

    Private Sub HabilitaBotoesLOG()
        cmb_CamadaLOG.Enabled = True
        cmb_NivelDepuracaoLOG.Enabled = True
        bt_AtivarLOG.Enabled = True
        bt_DesativarLOG.Enabled = False
    End Sub

    Private Sub DesabilitaBotoesLOG()
        cmb_CamadaLOG.Enabled = False
        cmb_NivelDepuracaoLOG.Enabled = False
        bt_AtivarLOG.Enabled = False
        bt_DesativarLOG.Enabled = True
    End Sub

    Private Sub HabilitaItemImpressao()
        ' Habilita itens p/ impressao simples
        If Opt_CupomSimples.Checked = True Then
            Edit_NLinhas.Enabled = True
            TXT_Impressao.Text = "IMPRIME LINHA"

            ' Habilita itens p/ impressao c/ atributos
        ElseIf Opt_CupomComAtributos.Checked = True Then
            Chk_Negrito.Enabled = True
            Chk_Italico.Enabled = True
            Chk_Sublinhado.Enabled = True
            Chk_Expandido.Enabled = True
            Chk_Condensado.Enabled = True
            Chk_TodosAtributos.Enabled = True
            TXT_Impressao.Enabled = True
            TXT_Impressao.Text = "TEXTO DE EXEMPLO"
            TXT_Impressao.MaxLength = 50

            ' Habilita itens p/ impressao de codigo de barras
        ElseIf Opt_CodigoDeBarras.Checked = True Then
            Chk_CodAcima.Enabled = True
            Chk_CodAbaixo.Enabled = True
            Opt_CodBarras2de5.Checked = System.Windows.Forms.CheckState.Checked
            Opt_CodBarras2de5.Enabled = True
            Opt_CodBarrasCode39.Enabled = True
            Opt_CodBarrasEAN8.Enabled = True
            Opt_CodBarrasEAN13.Enabled = True
            Opt_CodBarrasCode128.Enabled = True
            TXT_Impressao.Enabled = True
            TXT_Impressao.Text = "1234567890"
            ' Habilita itens p/ impressao de QRCode
        ElseIf Opt_CodBarrasQRCode.Checked = True Then
            cmb_ECC_Escolhido.Enabled = True
            Edit_QRCode_Larg.Enabled = True
            TXT_Impressao.Enabled = True
            TXT_Impressao.Text = StrQRCode_Dados
            ' Habilita itens p/ impressao por arquivo
        ElseIf Opt_ImprimirDeArquivo.Checked = True Then
            Group_EscolheArquivo.Enabled = True
            Drivelistbox.Enabled = True
            Dirlistbox.Enabled = True
            FileListBox.Enabled = True
            lbl_NomeArquivo.Enabled = True

        End If

    End Sub
    Private Sub DesabilitaItemImpressao()
        Chk_CodAbaixo.Enabled = False
        Chk_CodAbaixo.CheckState = System.Windows.Forms.CheckState.Unchecked
        Chk_Negrito.Enabled = False
        Chk_Negrito.CheckState = System.Windows.Forms.CheckState.Unchecked
        Chk_Italico.Enabled = False
        Chk_Italico.CheckState = System.Windows.Forms.CheckState.Unchecked
        Chk_Sublinhado.Enabled = False
        Chk_Sublinhado.CheckState = System.Windows.Forms.CheckState.Unchecked
        Chk_Expandido.Enabled = False
        Chk_Expandido.CheckState = System.Windows.Forms.CheckState.Unchecked
        Chk_Condensado.Enabled = False
        Chk_Condensado.CheckState = System.Windows.Forms.CheckState.Unchecked
        Chk_TodosAtributos.Enabled = False
        Chk_TodosAtributos.CheckState = System.Windows.Forms.CheckState.Unchecked
        Chk_CodAcima.Enabled = False
        Chk_CodAcima.CheckState = System.Windows.Forms.CheckState.Unchecked
        Opt_CodBarras2de5.Enabled = False
        Opt_CodBarrasCode39.Enabled = False
        Opt_CodBarrasEAN8.Enabled = False
        Opt_CodBarrasEAN13.Enabled = False
        Opt_CodBarrasCode128.Enabled = False
        cmb_ECC_Escolhido.Enabled = False
        Edit_QRCode_Larg.Enabled = False
        Edit_NLinhas.Enabled = False
        TXT_Impressao.Enabled = False
        TXT_Impressao.Font = VB6.FontChangeBold(TXT_Impressao.Font, False)
        TXT_Impressao.Font = VB6.FontChangeItalic(TXT_Impressao.Font, False)
        TXT_Impressao.Font = VB6.FontChangeUnderline(TXT_Impressao.Font, False)
        Group_EscolheArquivo.Enabled = False
        Drivelistbox.Enabled = False
        Dirlistbox.Enabled = False
        FileListBox.Enabled = False
        lbl_NomeArquivo.Enabled = False
    End Sub
    Private Sub EscolheAtributos()
        If Chk_Negrito.CheckState = System.Windows.Forms.CheckState.Checked Then
            TXT_Impressao.Font = VB6.FontChangeBold(TXT_Impressao.Font, True)
        Else
            TXT_Impressao.Font = VB6.FontChangeBold(TXT_Impressao.Font, False)
        End If

        If Chk_Italico.CheckState = System.Windows.Forms.CheckState.Checked Then
            TXT_Impressao.Font = VB6.FontChangeItalic(TXT_Impressao.Font, True)
        Else
            TXT_Impressao.Font = VB6.FontChangeItalic(TXT_Impressao.Font, False)
        End If

        If Chk_Sublinhado.CheckState = System.Windows.Forms.CheckState.Checked Then
            TXT_Impressao.Font = VB6.FontChangeUnderline(TXT_Impressao.Font, True)
        Else
            TXT_Impressao.Font = VB6.FontChangeUnderline(TXT_Impressao.Font, False)
        End If

        If (Chk_Condensado.CheckState = System.Windows.Forms.CheckState.Checked) And (Chk_Expandido.CheckState = System.Windows.Forms.CheckState.Checked) Then
            TXT_Impressao.Font = VB6.FontChangeName(TXT_Impressao.Font, ("Franklin Gothic Demi"))
        ElseIf (Chk_Condensado.CheckState = System.Windows.Forms.CheckState.Unchecked) And (Chk_Expandido.CheckState = System.Windows.Forms.CheckState.Checked) Then
            TXT_Impressao.Font = VB6.FontChangeName(TXT_Impressao.Font, ("Tahoma"))
        ElseIf (Chk_Condensado.CheckState = System.Windows.Forms.CheckState.Checked) And (Chk_Expandido.CheckState = System.Windows.Forms.CheckState.Unchecked) Then
            TXT_Impressao.Font = VB6.FontChangeName(TXT_Impressao.Font, ("Impact"))
        Else
            TXT_Impressao.Font = VB6.FontChangeName(TXT_Impressao.Font, ("MS Sans Serif"))
        End If

        If Chk_TodosAtributos.CheckState = System.Windows.Forms.CheckState.Checked Then
            Chk_Negrito.Enabled = False
            Chk_Negrito.CheckState = System.Windows.Forms.CheckState.Unchecked
            Chk_Italico.Enabled = False
            Chk_Italico.CheckState = System.Windows.Forms.CheckState.Unchecked
            Chk_Sublinhado.Enabled = False
            Chk_Sublinhado.CheckState = System.Windows.Forms.CheckState.Unchecked
            Chk_Expandido.Enabled = False
            Chk_Expandido.CheckState = System.Windows.Forms.CheckState.Unchecked
            Chk_Condensado.Enabled = False
            Chk_Condensado.CheckState = System.Windows.Forms.CheckState.Unchecked
            TXT_Impressao.ReadOnly = True
            TXT_Impressao.Text = "DEMONSTRACAO DE ATRIBUTOS"
        Else
            Chk_Negrito.Enabled = True
            Chk_Italico.Enabled = True
            Chk_Sublinhado.Enabled = True
            Chk_Expandido.Enabled = True
            Chk_Condensado.Enabled = True
            TXT_Impressao.ReadOnly = False
            TXT_Impressao.Text = "TEXTO DE EXEMPLO"
        End If
    End Sub

    Private Sub Opt_ImprimirDeArquivo_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Opt_ImprimirDeArquivo.CheckedChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            If eventSender.Checked Then
                Call DesabilitaItemImpressao()
                Call HabilitaItemImpressao()
            End If
        End If
    End Sub

    Private Sub Opt_PortaSerial_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Opt_PortaSerial.CheckedChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            If eventSender.Checked Then
                Call DesabilitaBotoesPortaComunicacaoParalela()
                Call DesabilitaBotoesPortaComunicacaoUSB()
                Call HabilitaBotoesPortaComunicacaoSerial()
            End If
        End If
    End Sub
    Private Sub Opt_PortaParalela_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Opt_PortaParalela.CheckedChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            If eventSender.Checked Then
                Call DesabilitaBotoesPortaComunicacaoSerial()
                Call DesabilitaBotoesPortaComunicacaoUSB()
                Call HabilitaBotoesPortaComunicacaoParalela()
            End If
        End If
    End Sub
    Private Sub Opt_PortaUSB_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Opt_PortaUSB.CheckedChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            If eventSender.Checked Then
                Call DesabilitaBotoesPortaComunicacaoParalela()
                Call DesabilitaBotoesPortaComunicacaoSerial()
                Call HabilitaBotoesPortaComunicacaoUSB()
            End If
        End If
    End Sub
    Private Sub Opt_CupomComAtributos_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Opt_CupomComAtributos.CheckedChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            If eventSender.Checked Then
                Call DesabilitaItemImpressao()
                Call HabilitaItemImpressao()
            End If
        End If
    End Sub
    Private Sub Opt_CupomSimples_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Opt_CupomSimples.CheckedChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            If eventSender.Checked Then
                Call DesabilitaItemImpressao()
                Call HabilitaItemImpressao()
            End If
        End If
    End Sub
    Private Sub Opt_CodigoDeBarras_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Opt_CodigoDeBarras.CheckedChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            If eventSender.Checked Then
                Call DesabilitaItemImpressao()
                Call HabilitaItemImpressao()
            End If
        End If
    End Sub
    Private Sub Opt_CodBarrasQRCode_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Opt_CodBarrasQRCode.CheckedChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            If eventSender.Checked Then
                Call DesabilitaItemImpressao()
                Call HabilitaItemImpressao()
            End If
        End If
    End Sub
    Private Sub Opt_CodBarras2de5_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Opt_CodBarras2de5.CheckedChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            If eventSender.Checked Then
                'TXT_Impressao.MaxLength = 10
                TXT_Impressao.Text = "1234567890"
            End If
        End If
    End Sub
    Private Sub Opt_CodBarrasCode39_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Opt_CodBarrasCode39.CheckedChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            If eventSender.Checked Then
                'TXT_Impressao.MaxLength = 12
                TXT_Impressao.Text = "1234567890AB"
            End If
        End If
    End Sub

    Private Sub Opt_CodBarrasEAN8_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Opt_CodBarrasEAN8.CheckedChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            If eventSender.Checked Then
                'TXT_Impressao.Maxlength = 7
                TXT_Impressao.Text = "1234567"
            End If
        End If
    End Sub
    Private Sub Opt_CodBarrasEAN13_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Opt_CodBarrasEAN13.CheckedChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            If eventSender.Checked Then
                'TXT_Impressao.Maxlength = 12
                TXT_Impressao.Text = "123456789012"
            End If
        End If
    End Sub
    Private Sub Opt_CodBarrasCode128_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Opt_CodBarrasCode128.CheckedChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            If eventSender.Checked Then
                'TXT_Impressao.Maxlength = 12
                TXT_Impressao.Text = "123456789012"
            End If
        End If
    End Sub
    Private Sub Chk_Negrito_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Chk_Negrito.CheckStateChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            Call EscolheAtributos()
        End If
    End Sub
    Private Sub Chk_Italico_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Chk_Italico.CheckStateChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            Call EscolheAtributos()
        End If
    End Sub
    Private Sub Chk_Sublinhado_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Chk_Sublinhado.CheckStateChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            Call EscolheAtributos()
        End If
    End Sub
    Private Sub Chk_Expandido_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Chk_Expandido.CheckStateChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            Call EscolheAtributos()
        End If
    End Sub

    Private Sub Chk_Condensado_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Chk_Condensado.CheckStateChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            Call EscolheAtributos()
        End If
    End Sub
    Private Sub Chk_TodosAtributos_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Chk_TodosAtributos.CheckStateChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            Call EscolheAtributos()
        End If
    End Sub

    Private Sub bt_AbrirPorta_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bt_AbrirPorta.Click
        Call DesabilitaBotoes()

        Call AbrirPorta()

        ' Verifica se porta est aberta
        If boPortaAberta = True Then
            ExibeMsgConclusao("A Porta de comunicao [" & PortaComunicacao & "] est aberta.")
            Call DesabilitaBotoesPortaComunicacao()
        Else
            ExibeMsgErro("No foi possivel abrir a Porta de comunicao [" & PortaComunicacao & "]")
        End If

        Call HabilitaBotoes()
    End Sub

    Private Sub bt_FecharPorta_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bt_FecharPorta.Click
        Call DesabilitaBotoes()

        If FecharPorta() = False Then
            ExibeMsgErro("Falha na funo: [FecharPorta]")
        Else
            ExibeMsgConclusao(("A Porta de comunicao [" & PortaComunicacao & "] est fechada."))
        End If

        Call HabilitaBotoes()
        Call HabilitaBotoesPortaComunicacao()

    End Sub

    Private Sub bt_Sair_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bt_Sair.Click
        Me.Close()
    End Sub

    Private Sub bt_AbreGaveta_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bt_AbreGaveta.Click
        ' Verifica se porta est aberta
        If boPortaAberta = False Then
            ExibeMsgErro(("A Porta de Comunicao est fechada. Verifique."))
            Exit Sub
        End If

        Call DesabilitaBotoes()

        ExibeMsgAguarde(("Enviando Pulso p/ abrir gaveta. Aguarde ..."))
        If PulsoDeGaveta() = True Then
            ExibeMsgConclusao(("Sucesso no envio do Pulso p/ abrir gaveta."))
        Else
            ExibeMsgErro(("Ocorreu algum erro durante o envio do Pulso p/ abrir gaveta.. Verifique."))
        End If

        Call HabilitaBotoes()
    End Sub

    Private Sub bt_ConfiguraTimeoutRXTX_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bt_ConfiguraTimeoutRXTX.Click
        ' Verifica se porta est aberta
        If boPortaAberta = False Then
            ExibeMsgErro(("A Porta de Comunicao est fechada. Verifique."))
            Exit Sub
        End If

        Call DesabilitaBotoes()

        ExibeMsgAguarde(("Configurando TimeOut de RX e TX. Aguarde ..."))
        If ConfigurarTimeoutRXTX(Val(txt_TimeoutRX.Text), Val(txt_TimeoutTX.Text)) = True Then
            ExibeMsgConclusao(("Sucesso ao configurar TimeOut de RX e TX."))
        Else
            MsgBox("Falha ao configurar TimeOut de RX e TX. Verifique.")
        End If

        Call HabilitaBotoes()
    End Sub

    Private Sub bt_SolicitaStatusPapel_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bt_SolicitaStatusPapel.Click
        ' Verifica se porta est aberta
        If boPortaAberta = False Then
            ExibeMsgErro(("A Porta de Comunicao est fechada. Verifique."))
            Exit Sub
        End If

        Call DesabilitaBotoes()

        ExibeMsgAguarde(("Enviando a solicitao de Status do tipo papel. Aguarde ..."))
        If EnviaTrata_StatusTipoPapel() = True Then
            ExibeMsgConclusao(("Sucesso na solicitao e recepo da resposta do Status do tipo papel."))
        Else
            ExibeMsgErro(("Ocorreu algum erro durante a solicitao de Status do tipo papel. Verifique."))
        End If

        Call HabilitaBotoes()
    End Sub

    Private Sub bt_SolicitaStatusGenerico_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bt_SolicitaStatusGenerico.Click
        ' Verifica se porta est aberta
        If boPortaAberta = False Then
            ExibeMsgErro(("A Porta de Comunicao est fechada. Verifique."))
            Exit Sub
        End If

        Call DesabilitaBotoes()

        ExibeMsgAguarde(("Enviando a solicitao de Status do tipo generico. Aguarde ..."))
        If EnviaTrata_StatusTipoGenerico() = True Then
            ExibeMsgConclusao(("Sucesso na solicitao e recepo da resposta do Status do tipo generico."))
        Else
            ExibeMsgErro(("Ocorreu algum erro durante a solicitao de Status do tipo generico. Verifique."))
        End If

        Call HabilitaBotoes()
    End Sub

    Private Sub bt_VerificaStatus_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bt_VerificaStatus.Click
        ' Verifica se porta est aberta
        If boPortaAberta = False Then
            ExibeMsgErro(("A Porta de Comunicao est fechada. Verifique."))
            Exit Sub
        End If

        Call DesabilitaBotoes()

        ExibeMsgAguarde(("Enviando a solicitao de status. Aguarde ..."))
        If VerificaTodosStatus() = True Then
            ExibeMsgConclusao(("Sucesso na solicitao e recepo da resposta do Status."))
        Else
            ExibeMsgErro(("Ocorreu algum erro durante a solicitao de Status. Verifique."))
        End If

        Call HabilitaBotoes()
    End Sub

    Private Sub bt_PreparaImpressao_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bt_PreparaImpressao.Click
        ' Verifica se porta est aberta
        If boPortaAberta = False Then
            ExibeMsgErro(("A Porta de Comunicao est fechada. Verifique."))
            Exit Sub
        End If

        Call DesabilitaBotoes()

        ExibeMsgAguarde(("Preparando para Imprimir Aguarde ..."))
        If PreparaImpressao() = True Then
            ExibeMsgConclusao(("Sucesso no envio do comando Prepara Impresso."))
        Else
            ExibeMsgErro(("Ocorreu algum erro durante o envio do comando Prepara Impresso. Verifique."))
        End If

        Call HabilitaBotoes()
    End Sub

    Private Sub bt_AguardaImpressao_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bt_AguardaImpressao.Click
        ' Verifica se porta est aberta
        If boPortaAberta = False Then
            ExibeMsgErro(("A Porta de Comunicao est fechada. Verifique."))
            Exit Sub
        End If

        Call DesabilitaBotoes()

        ExibeMsgAguarde(("Aguarde enquanto cupom  impresso ..."))
        If AguardaImpressao() = True Then
            ExibeMsgConclusao(("Impresso finalizada com Sucesso."))
        Else
            ExibeMsgErro(("Ocorreu algum erro durante Aguardar Impresso.. Verifique."))
        End If

        Call HabilitaBotoes()
    End Sub

    Private Sub bt_AcionaGuilhotina_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bt_AcionaGuilhotina.Click
        ' Verifica se porta est aberta
        If boPortaAberta = False Then
            ExibeMsgErro(("A Porta de Comunicao est fechada. Verifique."))
            Exit Sub
        End If

        Call DesabilitaBotoes()

        ExibeMsgAguarde(("Enviando o comando para acionar a guilhotina. Aguarde ..."))
        If Corta_Papel() = True Then
            ExibeMsgConclusao(("Sucesso no envio do comando para acionar a guilhotina."))
        Else
            ExibeMsgErro(("Ocorreu algum erro durante o envio do comando para acionar a guilhotina.. Verifique."))
        End If

        Call HabilitaBotoes()
    End Sub

    Private Sub bt_TratamentoCompleto_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bt_TratamentoCompleto.Click
        ' Verifica se porta est aberta
        If boPortaAberta = False Then
            ExibeMsgErro(("A Porta de Comunicao est fechada. Verifique."))
            Exit Sub
        End If

        Call DesabilitaBotoes()

        ExibeMsgAguarde(("Verificando se a impressora est Ok. Aguarde ..."))
        If VerificaTodosStatus() = False Then
            ExibeMsgErro(("A impressora est com algum problema. Verifique."))
            Call HabilitaBotoes()
            Exit Sub
        End If

        ExibeMsgAguarde(("Preparando impresso. Aguarde ..."))
        If PreparaImpressao() = False Then
            ExibeMsgErro(("Ocorreu algum problema ao Preparar a impresso. Verifique."))
            Call HabilitaBotoes()
            Exit Sub
        End If

        ExibeMsgAguarde(("Enviando o cupom a ser impresso. Aguarde ..."))
        If Imprime_Cupom() = False Then
            ExibeMsgErro(("Ocorreu algum problema ao enviar o cupom. Verifique."))
            Call HabilitaBotoes()
            Exit Sub
        End If

        ExibeMsgAcao(("Imprimindo cupom ..."))
        If AguardaImpressao() = False Then
            ExibeMsgErro(("Ocorreu algum problema ao imprimir o cupom. Verifique."))
            Call HabilitaBotoes()
            Exit Sub
        End If

        ExibeMsgAguarde(("Enviando o comando de corte de papel. Aguarde ..."))
        If Corta_Papel() = False Then
            ExibeMsgErro(("Ocorreu algum problema ao enviar o comando de corte de papel. Verifique."))
            Call HabilitaBotoes()
            Exit Sub
        End If

        ExibeMsgConclusao(("Cupom impresso com Sucesso."))

        Call HabilitaBotoes()
    End Sub

    Private Sub bt_AtivarLOG_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bt_AtivarLOG.Click
        ' Verifica se porta est aberta
        If boPortaAberta = False Then
            ExibeMsgErro(("A Porta de Comunicao est fechada. Verifique."))
            Exit Sub
        End If

        Call DesabilitaBotoes()

        ExibeMsgAguarde(("Ativando a gravao de Log. Aguarde ..."))
        If AtivarLOG(cmb_CamadaLOG.SelectedIndex, cmb_NivelDepuracaoLOG.SelectedIndex) = True Then
            ExibeMsgConclusao(("Sucesso ao ativar a gravao de Log."))
            Call DesabilitaBotoesLOG()
        Else
            ExibeMsgErro(("Ocorreu algum erro ao ativar a gravao de Log. Verifique."))
        End If

        Call HabilitaBotoes()
    End Sub

    Private Sub bt_DesativarLOG_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bt_DesativarLOG.Click
        ' Verifica se porta est aberta
        If boPortaAberta = False Then
            ExibeMsgErro(("A Porta de Comunicao est fechada. Verifique."))
            Exit Sub
        End If

        Call DesabilitaBotoes()

        ExibeMsgAguarde(("Desativando a gravao de Log. Aguarde ..."))
        If DesativarLOG(cmb_CamadaLOG.SelectedIndex) = True Then
            ExibeMsgConclusao(("Sucesso ao desativar a gravao de Log."))
            Call HabilitaBotoesLOG()
        Else
            ExibeMsgErro(("Ocorreu algum erro ao desativar a gravao de Log. Verifique."))
        End If

        Call HabilitaBotoes()
    End Sub

    Private Sub bt_StatusDoDispositivo_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bt_StatusDoDispositivo.Click
        'Verifica se porta est aberta
        If boPortaAberta = False Then
            ExibeMsgErro(("A Porta de comunicao est fechada. Verifique."))
            Exit Sub
        End If

        Call DesabilitaBotoes()

        ExibeMsgAguarde(("Enviando a solicitao de status. Aguarde ..."))
        If StatusDoDispositivo() = True Then
            ExibeMsgConclusao(("Sucesso no envio e recepo da resposta do Status."))
        Else
            ExibeMsgErro(("Ocorreu algum erro durante a solicitao de Status. Verifique."))
        End If

        Call HabilitaBotoes()
    End Sub

    Private Sub bt_ImprimeCupom_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bt_ImprimeCupom.Click
        ' Verifica se porta est aberta
        If boPortaAberta = False Then
            ExibeMsgErro(("A Porta de Comunicao est fechada. Verifique."))
            Exit Sub
        End If

        Call DesabilitaBotoes()

        ExibeMsgAguarde(("Imprimindo o cupom. Aguarde ..."))
        If Imprime_Cupom() = True Then
            ExibeMsgConclusao(("Sucesso na impresso do cupom."))
        Else
            ExibeMsgErro(("Ocorreu algum erro durante a impresso do cupom. Verifique."))
        End If

        Call HabilitaBotoes()
    End Sub

    Private Sub Drivelistbox_SelectedIndexChanged(sender As Object, e As EventArgs) Handles Drivelistbox.SelectedIndexChanged
        Try
            Dirlistbox.Path = Drivelistbox.Drive
            tempDrive = Drivelistbox.Drive
        Catch Exc As Exception
            MessageBox.Show(Exc.Message, "Erro!", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Drivelistbox.Drive = tempDrive
        End Try
    End Sub


End Class